# ADS2 - Implementierung in Python #

Im Ordner [./src/*](src/) findet Module mit Datenstrukturen und Algorithmen.

Im Ordner [./tests/*](tests/) findet man _unit tests_,
die die verschiedenen Datenstrukturen und Algorithmen mit Testfälle belasten.
Man kann auch direkt im Code von [./src/main.rs](src/main.rs) aus
die Methoden mit Daten ausprobieren.

## Voraussetzungen ##

1. Der Python-Compiler **`^3.10.*`** wird benötigt.
2. Es ist auch empfehlenswert, **`make`** zu installieren.
  - Linux/OSX: siehe <https://formulae.brew.sh/formula/make>.
  - Windows: siehe <https://community.chocolatey.org/packages/make>.

## Setup -> Test -> Run ##

In einem IDE in dem Repo zu diesem Ordner navigieren.
</br>
Eine bash-Konsole aufmachen und folgende Befehle ausführen:

Wer **make** installiert hat:
```bash
# Zur Installation der Requirements (nur nach Änderungen):
make setup;
# Zur Ausführung der unit tests:
make tests;
# Zur Ausführung des Programms
make run;
# Zur Bereinigung aller Artefakte
make clean;
```
Wer _kein_ make hat:
```bash
# Zur Installation der Requirements (nur nach Änderungen):
python3 -m pip install -r requirements;
# Zur Ausführung der unit tests:
python3 -m pytest tests --cache-clear --verbose -k test_;
# Zur Ausführung des Programms:
python3 src/main.py
```
Auf Windows verwendet man `py -3` od. `py -310` statt `python3`.

Man kann auch mit einem guten Editor/IDE die Tests einzeln ausführen.
